/*
Units V1.1 - A general units converter
Copyright (C) 1998 Franois Pessaux (francois.pessaux@inria.fr)


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include <Common.h>
#include <System/SysAll.h>
#define _DONT_USE_FP_TRAPS_ 1
#include <System/NewFloatMgr.h>
#include <UI/UIAll.h>
#include "protos.h"


#include "units.h"
#include "bool.h"

extern DmOpenRef unit_db ;
extern Word CurrentCategory ;
extern ListPtr TopList, BottomList, TopPrefList, BottomPrefList ;
extern Boolean pretty_floats ;


void EndApplication ()
{
  struct UnitPreferences prefs ;
  UInt record_index ;

  /* Sauve les prefecences */
  prefs.current_category = CurrentCategory ;

  /* Save pretty printing flag */
  prefs.pretty_floats = pretty_floats ;

  /* If unique ids are valid, the flag will be update below */
  prefs.ids_are_valid = FALSE ;

  /* Get unique ID for src unit */
  if (FindUnitRecordIndexByName (
        LstGetSelectionText (TopList, LstGetSelection (TopList)),
        &record_index, CurrentCategory)) {
    DmRecordInfo (unit_db, record_index, NULL, &prefs.src_unique_id, NULL) ;

    /* Get unique ID for src unit */
    if (FindUnitRecordIndexByName (
          LstGetSelectionText (BottomList, LstGetSelection (BottomList)),
         &record_index, CurrentCategory)) {
      DmRecordInfo (unit_db, record_index, NULL, &prefs.dest_unique_id, NULL) ;
      /* The 2 uniques ID are valid so all is valid */
      prefs.ids_are_valid = TRUE ;

      /* Get currently used prefixes */
      prefs.src_prefix = LstGetSelection (TopPrefList) ;
      prefs.dest_prefix = LstGetSelection (BottomPrefList) ;
    }
  }

  PrefSetAppPreferencesV10 (CAT_APP_ID, 0, &prefs,
			    sizeof (struct UnitPreferences)) ;

  /* On ferme la database */
  DmCloseDatabase (unit_db) ;
}
