/*
Units V1.1 - A general units converter
Copyright (C) 1998 Franois Pessaux (francois.pessaux@inria.fr)


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include <Common.h>
#include <System/SysAll.h>
#define _DONT_USE_FP_TRAPS_ 1
#include <System/NewFloatMgr.h>


/* Conversion Asci -> double */
void SysTrapFlpAToF(FlpDouble*, Char*) SYS_TRAP(sysTrapFlpDispatch);

double GccSysFlpAToF( char* s )
{
    FlpCompDouble fcd;
    asm("moveq.l %0,%%d2" : : "i" (sysFloatAToF) : "d2");
    SysTrapFlpAToF(&fcd.fd, s);
    return fcd.d;
}


/* Conversion double -> Asci */
void SysTrapFlpFToA (double, Char*) SYS_TRAP(sysTrapFlpDispatch);

void GccSysFlpFToA (double value, Char *buffer)
{
  asm("moveq.l %0,%%d2" : : "i" (sysFloatFToA) : "d2");
  SysTrapFlpFToA (value, buffer) ;
  return ;
}


/* Binary functions with type double -> double -> double */
void SysTrapFlpBinaryOp(FlpDouble*, double, double)
     SYS_TRAP(sysTrapFlpEmDispatch);

double GccSysFlpAdd (double d1, double d2)                      /* _d_add */
{
    FlpCompDouble fcd;
    asm("moveq.l %0,%%d2" : : "i" (sysFloatEm_d_add) : "d2");
    SysTrapFlpBinaryOp (&fcd.fd, d1, d2);
    return fcd.d;
}


double GccSysFlpSub (double d1, double d2)                      /* _d_sub */
{
    FlpCompDouble fcd;
    asm("moveq.l %0,%%d2" : : "i" (sysFloatEm_d_sub) : "d2");
    SysTrapFlpBinaryOp (&fcd.fd, d1, d2);
    return fcd.d;
}


double GccSysFlpMul (double d1, double d2)                      /* _d_mul */
{
    FlpCompDouble fcd;
    asm("moveq.l %0,%%d2" : : "i" (sysFloatEm_d_mul) : "d2");
    SysTrapFlpBinaryOp (&fcd.fd, d1, d2);
    return fcd.d;
}


double GccSysFlpDiv (double d1, double d2)                      /* _d_div */
{
    FlpCompDouble fcd;
    asm("moveq.l %0,%%d2" : : "i" (sysFloatEm_d_div) : "d2");
    SysTrapFlpBinaryOp (&fcd.fd, d1, d2);
    return fcd.d;
}


/* Binary functions with type double -> double -> double */
void SysTrapFlpComparOp(double, double) SYS_TRAP(sysTrapFlpEmDispatch);


SDWord GccSysFlpEq (double d1, double d2)                      /* _d_feq */
{
    asm("moveq.l %0,%%d2" : : "i" (sysFloatEm_d_feq) : "d2");
    SysTrapFlpComparOp (d1, d2) ;
    /* Assume D0 is already loaded */
    return ;
}

