/*
Units V1.1 - A general units converter
Copyright (C) 1998 Franois Pessaux (francois.pessaux@inria.fr)


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include <Common.h>
#include <System/SysAll.h>
#include <System/NewFloatMgr.h>
#include <UI/UIAll.h>

#include "bool.h"
#include "units.h"
#include "messages.h"


DmOpenRef unit_db ;   /* Pointeur sur la base de donnee generale */
Word CurrentCategory = dmAllCategories ;  /* Categorie active */
char CurrentCategoryName[dmCategoryLength] ; /* Nom de cette categorie */
char result_buffer[17] ; /* Format [-]x.yyyyyyyye[-]zz + \0 */

/* Elements de l'interface */
FormPtr MainForm ;
ListPtr TopList, BottomList, TopPrefList, BottomPrefList ;
ControlPtr TopTrigger, BottomTrigger, CategoryTrigger,
           TopPrefTrigger, BottomPrefTrigger ;
FieldPtr TopField, BottomField ;
ControlPtr ScientNotChkbox ;


/* Header pour les categories */
AppInfoType appinfo = {
  0,  /* Pas compris... */
  /* Liste de toutes les categories */
  UNITNAME_UNFILLED, UNITNAME_DISTANCE, UNITNAME_WEIGTHS,
  UNITNAME_PRESSURE, UNITNAME_SURFACE, UNITNAME_TEMPERATURE,
  UNITNAME_TIME, UNITNAME_VOLUME, 
  "", "", "", "",
  "", "", "", "",
  /* Category Uniq IDs */
  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 
  /* Last Uniq ID */
  15
};


char **UnitsLstItems=NULL ;  /* Pointeur sur les listes de chaines contenues */
                             /* dans la liste des unites */
                             /* dans les selecteur d'unites */
Word UnitsNbEntries=0 ;      /* nombre d'entrees dans ces listes */

/* Les prefixes doivent etre classes du plus petit au plus grand */
/* \265 = char code 181 = mu */
char prefixes_strings[17][3] = {
  "a " ,  "f " ,  "p " ,  "n " ,  "\265 " ,  "m " ,  "c " ,  "d " ,  "da" ,
  "h " ,  "k " ,  "M " ,  "G " ,  "T " ,  "P " ,  "E ",  "  "
};

char **FromPrefixesList=NULL ;
Word FromPrefixesNumber=0 ;
char **ToPrefixesList=NULL ;
Word ToPrefixesNumber=0 ;

unsigned char selection_continuation ;

/* Indique sur quelle unites on etait avant de switcher d'application */
Word last_saved_src=0, last_saved_dest=0 ;
/* Pareil pour les prefixes */
Word last_saved_pref_src=0, last_saved_pref_dest=0 ;
/* Indique si on doit afficher les floats en notation non scientifique */
Boolean pretty_floats = TRUE ;
