/*
Units V1.1 - A general units converter
Copyright (C) 1998 Franois Pessaux (francois.pessaux@inria.fr)


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include <Common.h>
#include <System/SysAll.h>
#define _DONT_USE_FP_TRAPS_ 1
#include <System/NewFloatMgr.h>
#include <UI/UIAll.h>
#include "protos.h"


#include "pilrc.h"
#include "units.h"
#include "bool.h"
#include "messages.h"


extern FormPtr MainForm ;
extern ListPtr TopList, BottomList, TopPrefList, BottomPrefList ;
extern ControlPtr TopTrigger, BottomTrigger, CategoryTrigger,
  TopPrefTrigger, BottomPrefTrigger ;
extern FieldPtr TopField, BottomField ;
extern ControlPtr ScientNotChkbox ;


void EventLoop (void)
{
  EventType event ;
  FormPtr form ;
  short error ;

  do {
    EvtGetEvent (&event, -1) ;
    if (SysHandleEvent (&event)) continue ;
    if (MenuHandleEvent ((void *)0, &event, &error)) continue ;

    if (event.eType == frmLoadEvent)
      {
	int formID ;

	formID = event.data.frmLoad.formID ;
	form = FrmInitForm (formID) ;
	FrmSetActiveForm (form) ;
	switch (formID) 
	  {
	  case mainForm:
	    /* Init des pointeurs globaux sur l'interface */
	    MainForm = form ;
	    TopList = FrmGetObjectPtr (MainForm,
                             FrmGetObjectIndex (MainForm, unitFromList)) ;
	    BottomList = FrmGetObjectPtr (MainForm,
			      FrmGetObjectIndex (MainForm, unitToList)) ;
            TopPrefList = FrmGetObjectPtr (MainForm,
			      FrmGetObjectIndex (MainForm, prefixFromList)) ;
            BottomPrefList = FrmGetObjectPtr (MainForm,
			      FrmGetObjectIndex (MainForm, prefixToList)) ;
	    TopTrigger = FrmGetObjectPtr (MainForm,
			      FrmGetObjectIndex (MainForm, unitFromTrigger)) ;
            BottomTrigger = FrmGetObjectPtr (MainForm,
                              FrmGetObjectIndex (MainForm, unitToTrigger)) ;
            TopPrefTrigger = FrmGetObjectPtr (MainForm,
                             FrmGetObjectIndex (MainForm, prefixFromTrigger)) ;
            BottomPrefTrigger = FrmGetObjectPtr (MainForm,
                              FrmGetObjectIndex (MainForm, prefixToTrigger)) ;
	    CategoryTrigger = FrmGetObjectPtr (MainForm,
                           FrmGetObjectIndex (MainForm, unitCategoryTrigger)) ;
	    TopField = FrmGetObjectPtr (MainForm, FrmGetObjectIndex
				                  (MainForm, iHaveField)) ;
            BottomField = FrmGetObjectPtr (MainForm, FrmGetObjectIndex
				              (MainForm, iGetField)) ;
	    ScientNotChkbox = FrmGetObjectPtr (MainForm, FrmGetObjectIndex
				              (MainForm, scientNotationChk)) ;

	    FrmSetEventHandler (form, (FormEventHandlerPtr) MainEventHandler) ;
	    break ;

	  case definitionUnitForm:
	      FrmSetEventHandler (form,
				  (FormEventHandlerPtr) NewUnitEventHandler) ;
	    break ;

	  case selectUnitForm:
	    FrmSetEventHandler (form,
				(FormEventHandlerPtr) SelectUnitEventHandler) ;
	    break ;
	  }
      }
    FrmDispatchEvent (&event) ;
  } while (event.eType != appStopEvent) ;

  EndApplication () ;
}





DWord  PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags)
{
  if (cmd == sysAppLaunchCmdNormalLaunch)
    {
      if (InitApplication ()) {
	FrmGotoForm (mainForm) ;
	EventLoop () ;
      }
      else FrmCustomAlert (standardErrorAlert,
			   MSG_CANT_CREATE_DB, NULL, NULL) ;
    }
  return (0) ;
}
